require('lib/registry.js');

var list = [];

function collect(query,results) {
    if(!results.expects('INSTALLEDAPP'))
        return;

    // only update when query is empty : this is too slow otherwise
    if (query == "") {
        list = [];
        var keys = regEnumKeys(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall");
        for (var i = 0; i < keys.length; i++) {
            var displayName = regQueryValue(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\" + keys[i], "DisplayName");
            var uninstallString = regQueryValue(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\" + keys[i], "UninstallString");
            if(uninstallString!=0)
                list.push({ 'key': keys[i], 'icon': 'plugins\\uninstall\\server.png', 'text': displayName, 'path': uninstallString });
        }

        var keys = regEnumKeys(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall");
        for (var i = 0; i < keys.length; i++) {
            var displayName = regQueryValue(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\" + keys[i], "DisplayName");            
            var uninstallString = regQueryValue(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\" + keys[i], "UninstallString");
            if (uninstallString != 0)
                list.push({ 'key': keys[i], 'icon': 'plugins\\uninstall\\server.png', 'text': displayName, 'path': uninstallString });
        }
    }

    for (var i = 0; i < list.length; i++) {
        if (qatapult.match(list[i].text, query))
            results.addObject('INSTALLEDAPP', list[i].key, list[i]);
    }
}
